\documentclass[a4paper,UTF8]{ctexart}
\usepackage{listings}
\usepackage{amsmath}
\newfontfamily\codefont{DejaVu Sans Mono}
\setmonofont{DejaVu Sans Mono}
\lstset{basicstyle=\small\codefont,frame=single,numbers=left}
\setCJKmainfont[Mapping = fullwidth-stop, % 中文空心句号映射为实心句点
  BoldFont=FZHei-B01,ItalicFont=FZKai-Z03,
  BoldItalicFont=FZFangSong-Z02]{FZNewShuSong-Z10}

\begin{document}
\subsection*{2021“津门杯”网络安全创新大赛，Crypto，混合编码}

题目是以下“混合编码.txt”文件。

\begin{lstlisting}[numbers=none]
JTJGMTAyJTJGMTA4JTJGOTclMkYxMDMlMkYxMjMlMkYxMTMlMkY0OSUyRjEyMCUy
Rjc1JTJGMTEyJTJGMTA5JTJGNTYlMkYxMTglMkY3MyUyRjc2JTJGODclMkYxMTQl
MkYxMDclMkYxMDklMkY4OCUyRjEyMCUyRjg2JTJGNTQlMkYxMDYlMkY0OSUyRjQ5
JTJGNzclMkYxMDAlMkY5OSUyRjcxJTJGMTE2JTJGNzYlMkYxMjIlMkYxMTglMkY4
MiUyRjEyMSUyRjg2JTJGMTI1
\end{lstlisting}

\subsection*{解答}

使用以下命令进行 base64 解码。
\begin{lstlisting}[numbers=none]
$ cat 混合编码.txt | base64 -d > /tmp/a.txt
$ cat /tmp/a.txt
%2F102%2F108%2F97%2F103%2F123%2F113%2F49%2F120%2F75%2F112%2F109
%2F56%2F118%2F73%2F76%2F87%2F114%2F107%2F109%2F88%2F120%2F86%2F
54%2F106%2F49%2F49%2F77%2F100%2F99%2F71%2F116%2F76%2F122%2F118%
2F82%2F121%2F86%2F125
\end{lstlisting}

使用以下命令把“{\tt{\%2F}}”替换为空格。

\begin{lstlisting}[numbers=none]
$ sed 's/%2F/ /g' /tmp/a.txt > /tmp/b.txt
$ cat /tmp/b.txt
 102 108 97 103 123 113 49 120 75 112 109 56 118 73 76 87 114
107 109 88 120 86 54 106 49 49 77 100 99 71 116 76 122 118 82
121 86 125
\end{lstlisting}

运行以下 solve.py 程序得到答案。

\lstinputlisting[language=python]{solve.py}

\begin{lstlisting}[numbers=none]
$ python solve.py < /tmp/b.txt
flag{q1xKpm8vILWrkmXxV6j11MdcGtLzvRyV}
\end{lstlisting}

\end{document}
